#include <iostream>
#include <string.h>
#include <cstdlib>
#include <fstream>
#include <charconv>

using namespace std;

class MyString{
	public:
		MyString(int id);
		MyString(int id, char *);
		~MyString();
		void print(void);
		void set(char *);
		void update(void);
	private:
		int id;
		void create_file();
		void open_file();
		void close_file();
		char *get_string_from_file();
		ofstream file_in;
		ifstream file_out;
		string file_name;
};


MyString::MyString(int id, char *str){
	cout << "Создание объекта\n";
	MyString::id = id;
	create_file();
	file_in << str << endl;
	close_file();
}

MyString::MyString(int id){
	cout << "Создание объекта\n";
	MyString::id = id;	
	create_file();
	close_file();
}


void MyString::create_file(){

    string file_id = to_string(id);

    file_name = "string" + file_id + ".txt";

	file_in.open(file_name, ios_base::trunc); // чистим файл
	file_in.close();
	file_in.open(file_name, ios_base::app);
	file_in << "Исходная строка:\n";
}


void MyString::open_file(){
	MyString::file_in.open(file_name, ios_base::app);
}


void MyString::close_file(){
	MyString::file_in.close();
	MyString::file_out.close();
}


char* MyString::get_string_from_file(){
	file_out.open(file_name, ios_base::in);
	char* data = new char[501];
	file_out.getline(data, 500); // читаем "лишнюю строку"
	file_out.getline(data, 500); //  читаем нужную строку
	close_file();
	return data;	
}


void MyString::print(void){
	char *str = get_string_from_file();
	cout << str << endl;
}

void MyString::set(char *str){
	cout << "Изменение объекта\n";
	open_file();
	cout << str << endl;
	MyString::file_in << str << endl;
	close_file();
}

void MyString::update(void){
	char *str = get_string_from_file();
	int strLength = mbstowcs(NULL, str, 0); // длинна строки (возможно не будет работать на windows)
	open_file();
	if(strLength % 5 == 0){
		int count = 0;
		for (int i = 0; i < strLength; ++i){
			if(str[i] == '(' || str[i] == ')' || str[i] == '{' || str[i] == '}' || str[i] == '[' || str[i] == ']'){
				count++;
			}
		}
		cout << "Кол-во скобок: " << count << endl;
		file_in << "Кол-во скобок: " << endl << count << endl;
	}else{
		cout << "Длинна строки не кратна 5! \n";
		file_in << "Длинна строки не кратна 5! \n";
	}
	close_file();
}

MyString::~MyString(void){
	cout << "Уничтожение объекта\n";
	close_file();

}

int main(void){
	setlocale(LC_ALL, "ru_RU.utf8");
	int id = 0;
	char in1[99];
	char in2[99];
	cout << "STR1: ";
	cin.getline(in1, 99);
	MyString str1(id++, in1);
	MyString str2(id++);
	cout << "STR2: ";
	cin.getline(in2, 99);
	str2.set(in2);
	str1.print();
	str1.update();
	str1.print();
	str2.print();
	str2.update();
	str2.print();
}